<template>
    <b-overlay :show="showOverlay" rounded="sm">
        <b-form @submit="onSubmit">
            <b-form-group
                id="input-group-phone-number"
                description="Enter a phone number to verify on the field above"
            >
                <b-form-input
                    size="sm"
                    id="inputPhoneNumber"
                    name="phone_number"
                    v-model="phoneNumber"
                    type="tel"
                    required
                    placeholder="Enter a phone number"
                    autocomplete="off"
                ></b-form-input>
            </b-form-group>

            <div>
                <b-button type="submit" variant="primary" size="sm">Test number</b-button>&nbsp;
            </div>

            <modal-single-test-result ref="modalResult"></modal-single-test-result>
        </b-form>
    </b-overlay>
</template>

<script>
import PhoneNumberService from "../services/phone-number-service";
import ModalSingleTestResult from "./ModalSingleTestResult";
import { EventBus } from "../plugins/global-event-bus";
import { VUE_GLOBAL_EVENT_PHONE_LIST_UPDATED } from "../configs/config";

export default {
    name: "FormTestPhoneNumber",
    components: {
        ModalSingleTestResult,
    },
    data() {
        return {
            phoneNumber: '',
            showOverlay: false,
            result: null,
        };
    },
    methods: {
        onSubmit(evt) {
            evt.preventDefault();

            PhoneNumberService.test(this.phoneNumber)
                .then((result) => {
                    console.log(result);

                    this.phoneNumber = '';
                    this.$refs.modalResult.show();
                    this.$refs.modalResult.setPhoneNumber(result);

                    EventBus.$emit(VUE_GLOBAL_EVENT_PHONE_LIST_UPDATED);
                })
                .catch((err) => {
                    console.log(err);
                    this.$bvModal.msgBoxOk(
                        `Test failed with the following error: ${err.message}`,
                        {
                            title: "Test failed",
                            buttonSize: "sm",
                            okVariant: "danger",
                        }
                    );
                })
                .finally(() => {
                    this.showOverlay = false;
                });
        }
    },
};
</script>
